config/routes.rb
Rails.application.routes.draw do

  root 'index#index'

  devise_for :users, controllers: { sessions: 'users/sessions', omniauth_callbacks: 'omniauth_callbacks' }
  
  devise_for :admin, controllers: { sessions: 'admin/sessions' }
  
  devise_for :scores
  
  get 'admin/index'
  
  get 'users/scores'
  
  match 'scores/copy/:id' => 'scores#copy', via: [:post], :as => :copy
  
  match '/users/:id/finish_signup' => 'users#finish_signup', via: [:get, :patch], :as => :finish_signup
  
  resources :users do
    member do
      get :download_score
    end
  end
  
  resources :scores do
    member do
      put :convert
      put :unshare
      put :share
    end
  end
  

end

app/views/layouts/_bootstrap3.html.erb
    <%= stylesheet_link_tag 'bootstrap3.min', media: 'all', 'data-turbolinks-track' => true %>
    <%= javascript_include_tag 'bootstrap3.min', 'data-turbolinks-track' => true %>

app/views/layouts/_core_bootstrap.html.erb
    <!-- Bootstrap core JavaScript-->
    <%= javascript_include_tag 'jquery-3.1.1.slim.min', 'data-turbolinks-track' => true %>
    <%= javascript_include_tag 'jquery.min', 'data-turbolinks-track' => true %>
    <%= javascript_include_tag 'tether.min', 'data-turbolinks-track' => true %>
    
    <!-- IE10 viewport hack for Surface/desktop Windows 8 bug -->
    <%= javascript_include_tag 'ie10-viewport-bug-workaround', 'data-turbolinks-track' => true %>

app/views/layouts/_meta.html.erb
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
<meta name="description" content="Convert your sheet music, it's fast and it's free!">
<meta name="author" content="Patrick L.">

app/views/layouts/_modals.html.erb
    <%= stylesheet_link_tag 'bootstrap3.min', media: 'all', 'data-turbolinks-track' => true %>
    <%= javascript_include_tag 'bootstrap3.min', 'data-turbolinks-track' => true %>
    <!-- Bootstrap Modal CSS -->
    <%= stylesheet_link_tag 'bootstrap-modal.min.css', media: 'all', 'data-turbolinks-track' => true %>
    <%= stylesheet_link_tag 'bootstrap-modal-bs3patch.min', media: 'all', 'data-turbolinks-track' => true %>
    <!-- Bootstrap Modal JavaScript-->
    <%= javascript_include_tag 'bootstrap-modal.min.js', 'data-turbolinks-track' => true %>
    <%= javascript_include_tag 'bootstrap-modalmanager.min', 'data-turbolinks-track' => true %>

app/views/layouts/_navbar.html.erb
<% if user_signed_in? ? @welcome = " - Welcome #{current_user.first_name}".html_safe : @welcome = nil %><% end %>

<div class="container">

    <div class="masthead">
        <div class="row">
          <div class="col-md-9"><h3 class="text-muted">Sheet Music Analyser<%= @welcome %></h3></div>
        </div>

        <nav class="navbar navbar-light bg-faded rounded mb-3">
          <div class="container">
              <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarCollapse" aria-controls="navbarCollapse" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
              </button>
              <% if (!user_signed_in?) && (!admin_signed_in?) %>
                  <%= link_to "Log in", "#login", "data-toggle" => "modal", :class => 'btn btn-default navbar-btn btn-small btn-info' %>
                  <%= link_to '<i class="fa fa-google-plus-square"></i>'.html_safe, user_google_oauth2_omniauth_authorize_path, class: 'btn btn-social-icon btn-google navbar-btn' %>
                  <%= link_to '<i class="fa fa-facebook-square"></i>'.html_safe, user_facebook_omniauth_authorize_path, class: 'btn btn-social-icon btn-facebook navbar-btn' %>
                  <%= link_to "Sign up", "#sign_up", "data-toggle" => "modal", :class => 'btn btn-default navbar-btn btn-small btn-info' %>
              <% end %>
              <% if user_signed_in? %>
                  <%= link_to "My profile", current_user, :class => 'btn navbar-btn btn-small btn-info' %>
                  <%= link_to "My scores", users_scores_path, :class => 'btn navbar-btn btn-small btn-info' %>
                  <%= link_to "Public scores", scores_path, :class => 'btn navbar-btn btn-small btn-primary' %>
                  <%= link_to('Log out', destroy_user_session_path, :method => :delete, :class => 'navbar-nav navbar-right btn navbar-btn btn-small btn-danger') %>
              <% end %>
              <% if admin_signed_in? %>
                  <%= link_to('Log out', destroy_admin_session_path, :method => :delete, :class => 'btn navbar-btn btn-small btn-danger') %>
              <% end %>
          </div>
          
          <div class="collapse navbar-toggleable-md" id="navbarCollapse">
            <ul class="nav navbar-nav text-md-center justify-content-md-between">
              <li class="nav-item active">
                <%= link_to "Home", root_path, :class => 'nav-link' %>
              </li>
              <li class="nav-item">
                <%= link_to "Downloads", scores_path, :class => 'nav-link' %>
              </li>
              <li class="nav-item">
                <%= link_to "Help", root_path, :class => 'nav-link' %>
              </li>
              <li class="nav-item">
                <%= link_to "Contact Us", root_path, :class => 'nav-link' %>
              </li>
              <li class="nav-item">
                <%= link_to "About", root_path, :class => 'nav-link' %>
              </li>
            </ul>
          </div>
        </nav>
    </div>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Workspace</title>
  <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <%= csrf_meta_tags %>
  
  <% render "layouts/meta" %>
  <%= render "layouts/core_bootstrap" %>

  <%= yield %>
</head>
<body>

</body>
</html>

app/views/layouts/index.html.erb
<!DOCTYPE html>
<html>
<head>
    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track' => true %>
    <%= stylesheet_link_tag 'justified-nav', media: 'all', 'data-turbolinks-track' => true %>
    <%= stylesheet_link_tag 'font-awesome', media: 'all', 'data-turbolinks-track' => true %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
    <%= csrf_meta_tags %>
    
    <!-- Bootstrap social buttons CSS -->
    <%= stylesheet_link_tag 'bootstrap-social', media: 'all', 'data-turbolinks-track' => true %>
    
    <script type="text/javascript"> $(function (){ $("#myModal").modal({show:false }); </script>
    <%= render "layouts/modals" %>
    <%= render "layouts/core_bootstrap" %>
    <%= render "users/login_modal" %>
    <%= render "users/sign_up_modal" %>
    <%= render "scores/new_modal" %>

</head>
<body>
    <%= render "layouts/navbar" %>
    <%= yield %>
</body>
</html>

app/views/layouts/scores.html.erb
<!DOCTYPE html>
<html>
<head>
    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track' => true %>
    <%= stylesheet_link_tag 'justified-nav', media: 'all', 'data-turbolinks-track' => true %>
    <%= stylesheet_link_tag 'font-awesome', media: 'all', 'data-turbolinks-track' => true %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
    <%= csrf_meta_tags %>
    
    <!-- Bootstrap social buttons CSS -->
    <%= stylesheet_link_tag 'bootstrap-social', media: 'all', 'data-turbolinks-track' => true %>
    
    <script type="text/javascript"> $(function (){ $("#myModal").modal({show:false }); </script>
    <%= render "layouts/modals" %>
    <%= render "layouts/core_bootstrap" %>
    <%= render "users/login_modal" %>
    <%= render "users/sign_up_modal" %>
    <%= render "scores/new_modal" %>
    <%= render "scores/details_modal" %>

</head>
<body>
    <%= render "layouts/navbar" %>
    <%= yield %>  
</body>
</html>

app/views/layouts/users.html.erb
<!DOCTYPE html>
<html>
<head>
    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track' => true %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
    <%= stylesheet_link_tag 'justified-nav', media: 'all', 'data-turbolinks-track' => true %>
    <%= csrf_meta_tags %>
    
    <!-- Bootstrap social buttons CSS -->
    <%= stylesheet_link_tag 'bootstrap-social', media: 'all', 'data-turbolinks-track' => true %>
    
    <script type="text/javascript"> $(function (){ $("#myModal").modal({show:false }); </script>
    <%= render "layouts/modals" %>
    <%= render "layouts/core_bootstrap" %>
    <%= render "scores/new_modal" %>

</head>
<body>
    <%= render "layouts/navbar" %>
    <%= yield %>  
</body>
</html>